"use strict";
var path$$ = require("path"), micromatch$$ = require("micromatch"), $$utils$ensureArray$$ = require("./utils/ensureArray");

function createFilter(include, exclude) {
	const getMatcher = id => ( isRegexp( id ) ? id : { test: micromatch$$.matcher( path$$.resolve( id ) ) } );
	include = $$utils$ensureArray$$["default"]( include ).map( getMatcher );
	exclude = $$utils$ensureArray$$["default"]( exclude ).map( getMatcher );

	return function ( id ) {

		if ( typeof id !== 'string' ) return false;
		if ( /\0/.test( id ) ) return false;

		id = id.split( path$$.sep ).join( '/' );

		for ( let i = 0; i < exclude.length; ++i ) {
			const matcher = exclude[i];
			if ( matcher.test( id ) ) return false;
		}

		for ( let i = 0; i < include.length; ++i ) {
			const matcher = include[i];
			if ( matcher.test( id ) ) return true;
		}

		return !include.length;
	};
}

exports["default"] = createFilter;

function isRegexp ( val ) {
	return val instanceof RegExp;
}